local _G = _G

------------------------------------------------------------------
function ShortNumber (n)
    if not n then return end
    if n<10000 then
        return _G.tostring(n)
    elseif n<10000000 then
        return _G.tostring(_G.floor((n+500)/1000))..'K'
    else
        return _G.tostring(_G.floor((n+500000)/1000000))..'M'
    end
end

------------------------------------------------------------------

function dumptbl (tbl, indent)
    if not tbl then return end
    indent = indent or 0
    for k,v in pairs(tbl) do
        if type(v)=='table' then
            print (strrep(' ',indent)..tostring(k),'table')
            dumptbl(v,indent+2)
        else
            print (strrep(' ',indent)..tostring(k),v)
        end
    end
end
------------------------------------------------------------------

function NewTexture (parent,anchor,x,y,w,h)
    local ret = parent:CreateTexture ('Texture', "HIGH")
    ret:SetPoint (anchor,x,y)
    ret:SetSize (w,h)
    
    return ret
end
------------------------------------------------------------------

function NewCooldown (parent,anchor,x,y,w,h)
    local ret = CreateFrame ('Cooldown', nil, parent)
    ret:SetPoint (anchor,x,y)
    ret:SetSize (w,h)   
    
    return ret
end
------------------------------------------------------------------

function NewButtonClose (parent,x,y,w,h)
    local ret = CreateFrame ("Button", nil, parent, "UIPanelCloseButton")
    ret:SetPoint("TOPRIGHT",parent,"TOPRIGHT",-x,-y)
    ret:SetSize(w,h)
    
    return ret
end
------------------------------------------------------------------

local icons -- Assigned later
function FindIcons (spellName)
    -- I really have no better way of finding icons! :(
    local ret = {}
    local found = {}
    local wantedName = string.trim (string.lower (spellName))
    local icon 
    
    if wantedName=='' then
        return ret
    end
    
    for name,icon in pairs(MooTrack_icons) do
        if name:match (wantedName) then
            found[icon] = true
        end
    end
    
    for icon,_ in pairs(found) do
        table.insert (ret, icon)
    end
    
    return ret
end

------------------------------------------------------------------

function GenerateFrameName (name)
    i = 1
    name = string.gsub (name, ' ', '')
    while true do 
        ret = name..tostring(i)
        if not _G[ret] then
            return ret
        else
            i = i+1
        end
    end
end

------------------------------------------------------------------

function GetAuraData (unit, aura)
    local name, rank, icon, count, dispelType, duration, expires, caster, isStealable, shouldConsolidate, spellID, canApplyAura, isBossDebuff, value1, value2, value3 = _G.UnitAura(unit, aura)
    if not name then
        name, rank, icon, count, dispelType, duration, expires, caster, isStealable, shouldConsolidate, spellID, canApplyAura, isBossDebuff, value1, value2, value3 = _G.UnitDebuff(unit, aura)
    end
    
    return name, rank, icon, count, dispelType, duration, expires, caster, isStealable, shouldConsolidate, spellID, canApplyAura, isBossDebuff, value1, value2, value3
end

